<?php

class tx_timedugs_sv1 extends TYPO3\CMS\Sv\AuthenticationService { 

	/**
	 * Find usergroup records, currently only for frontend
	 *
	 * @param	array		Data of user.
	 * @param	array		Group data array of already known groups. 
	 *                      This is handy if you want select other related groups. 
	 *                      Keys in this array are unique IDs of those groups.
	 * @return	mixed		Groups array, keys = uid which must be unique
	 */
	function getGroups($user, $knownGroups)	{
		$groupDataArr = array();

		if($this->mode=='getGroupsFE')	{

			$groups = array();
			if (is_array($user) && $user[$this->db_user['usergroup_column']])	{
			        // get std-grouplist for user
				$groupList = $user[$this->db_user['usergroup_column']];

				// get list of timed groups before reading full group-list
				$timedGroups = $user['tx_timedugs_grp'];
				if (!empty($timedGroups)) {
				        // only if list is not empty
					$selectFields = 'group_uid';
					$fromTable    = 'tx_timedugs_mm_recs';
					$whereClause  = 'uid in ('.$timedGroups.')';
					$addWhere = ' AND NOT deleted'
					           .' AND starttime <= '.$GLOBALS['SIM_EXEC_TIME']
					           .' AND (endtime=0 OR '.$GLOBALS['SIM_EXEC_TIME'].' <= endtime)';
					$groupBy = '';
					$orderBy = '';
					$limit = '';
					// get all groups which are available 'now'
					$recordList = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows( 
					    $selectFields, 
					    $fromTable, 
					    $whereClause
                         . $addWhere
                         . $hiddenP, 
					    $groupBy, 
					    $orderBy, 
					    $limit
                    );
					$timedGroupListArray = array();
					// add dynamic groups
					foreach ((array)$recordList as $record) {
					        $timedGroupListArray[] = $record['group_uid'];
					}
					if (count($timedGroupListArray)) {
						// add comma-separated list to original list
					        $groupList .= ',' . implode(',', $timedGroupListArray);
					}
				}

				// fetch full group-information (recursive)
				$groups = array();
				$this->getSubGroups($groupList, '', $groups);
			}

			// ADD group-numbers if the IPmask matches.
			if (is_array($GLOBALS['TYPO3_CONF_VARS']['FE']['IPmaskMountGroups']))	{
				foreach($GLOBALS['TYPO3_CONF_VARS']['FE']['IPmaskMountGroups'] as $IPel)	{
					if (   $this->authInfo['REMOTE_ADDR'] 
					    && $IPel[0] 
					    && t3lib_div::cmpIP(
					        $this->authInfo['REMOTE_ADDR'],
					        $IPel[0]
					        )
					) {
					    $groups[] = intval($IPel[1]);
					}
				}
			}

			$groups = array_unique($groups);

			if (count($groups))	{
				$list = implode(',', $groups);

				if ($this->writeDevLog) {
				    TYPO3\CMS\Core\Utility\GeneralUtility::devLog('Get usergroups with id: '. $list, __CLASS__);
				}

				$lockToDomain_SQL = ' AND (   lockToDomain="" '
				                        . 'OR lockToDomain IS NULL '
				                        . 'OR lockToDomain="' . $this->authInfo['HTTP_HOST'] . '")';
				if (!$this->authInfo['showHiddenRecords']) {
				    $hiddenP = ' AND hidden=0 ';
				}
				$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery(
				    '*', 
				    $this->db_groups['table'], 
				    'deleted=0 ' . $hiddenP . ' AND uid IN (' . $list . ')' . $lockToDomain_SQL 
				);
				while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))	{
					$groupDataArr[$row['uid']] = $row;
				}
				if ($res) {
				    $GLOBALS['TYPO3_DB']->sql_free_result($res);
				}

			} else {
				if ($this->writeDevLog) {
				    TYPO3\CMS\Core\Utility\GeneralUtility::devLog('No usergroups found.', __CLASS__, 2);
				}
			}
		} elseif ($this->mode == 'getGroupsBE') {

			# Get the BE groups here
			# still needs to be implemented in t3lib_userauthgroup
		}

		return $groupDataArr;
	}

}

